/*
  This program is just a helper utility for the orrery program.   It processes a
  list of star names and coordinates, and stores them in a binary file, in
  order to minimizr the size of the files required on the OM phone.
  It also converts the coordinates to radians, so that step does not need
  to be done by the orrery at runtime.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <math.h>

#define TRUE (1)
#define FALSE (0)

typedef struct __attribute__((packed)) starName {
  unsigned short offset; /* Offset to star name within bigStarNameString */
  float rARad;
  float decRad;
} starName;

char *bigStarNameString = NULL;

starName stars[1000];

/*
  Read a line of text from the config file, and strip comments (flagged by #).
*/
int getLine(int fD, char *buffer, int *eOF)
{
  char inChar = (char)0;
  int count = 0;
  int sawComment = FALSE;
  int foundSomething = FALSE;

  buffer[0] = (char)0;
  while ((!(*eOF)) && (inChar != '\n') && (count < 132)) {
    int nChar;

    nChar = read(fD, &inChar, 1);
    if (nChar > 0) {
      foundSomething = TRUE;
      if (inChar == '#')
        sawComment = TRUE;
      if (!sawComment)
        buffer[count++] = inChar;
    } else {
      *eOF = TRUE;
    }
  }
  if (foundSomething) {
    if (count > 0)
      buffer[count-1] = (char)0;
    return(TRUE);
  } else
    return(FALSE);
}

main()
{
  int i, outFile, negZero;
  unsigned short nStars = 0;
  int bigStringLength = 0;
  int inFD;
  int eof = 0;
  char inLine[200];

  inFD = open("starNames.txt", O_RDONLY);
  while (!eof) {
    int nRead, rAHH, rAMM, decDD, decMM;
    double rA, dec, rASS, decSS, decSign;
    char name[100];

    getLine(inFD, &inLine[0], &eof);
    nRead = sscanf(inLine, "%s %d %d %lf %d %d %lf",
		   &name, &rAHH, &rAMM, &rASS,
		   &decDD, &decMM, &decSS);
    if ((nRead == 7) && (!eof)) {
      for (i = 0; i < strlen(name); i++)
	if (name[i] == '_')
	  name[i] = ' ';
      rA = (double)rAHH + ((double)rAMM)/60.0 + rASS/3600.0;
      rA *= M_PI/12.0;
      if (strstr(inLine, "-00 ") == NULL)
	negZero = FALSE;
      else
	negZero = TRUE;
      if ((decDD < 0) || negZero){
	decSign = -1.0;
	decDD *= -1;
      } else
	decSign = 1.0;
      dec = (double)decDD + ((double)decMM)/60.0 + decSS/3600.0;
      dec *= decSign * M_PI/180.0;      
      bigStarNameString = realloc(bigStarNameString,
				  (strlen(name)+1)+bigStringLength);
      strcpy(&bigStarNameString[bigStringLength], name);
      stars[nStars].offset = bigStringLength;
      stars[nStars].rARad = (float)rA;
      stars[nStars].decRad = (float)dec;
      printf("\"%s\"\t\n", &bigStarNameString[bigStringLength]);
      bigStringLength += strlen(name)+1;
      nStars++;
    }
  }
  outFile = open("starNames.dat", O_WRONLY | O_CREAT);
  if (outFile < 0) {
    perror("Making output file");
    exit(-1);
  }
  write(outFile, &nStars, 2);
  for (i = 0; i < nStars; i++)
    write(outFile, &stars[i], sizeof(stars[i]));
  write(outFile, &bigStringLength, sizeof(bigStringLength));
  write(outFile, bigStarNameString, bigStringLength);
  printf("nStars = %d, stringLength = %d\n",
	 nStars, bigStringLength);
}
